<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "crawler".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Crawler".
 *
 * Columns in table "crawler" available as properties of the model,
 * followed by relations of table "crawler" available as properties of the model.
 *
 * @property integer $id
 * @property string $directory_url
 * @property string $directory_name
 * @property string $date_added
 * @property string $date_updated
 *
 * @property CrawlerProvider[] $crawlerProviders
 */
abstract class BaseCrawler extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'crawler';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Crawler|Crawlers', $n);
    }

    public static function representingColumn()
    {
        return 'directory_url';
    }

    public function rules()
    {
        return array(
            array('directory_url, date_added', 'required'),
            array('directory_url', 'length', 'max'=>255),
            array('directory_name', 'length', 'max'=>80),
            array('date_updated', 'safe'),
            array('directory_name, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, directory_url, directory_name, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'crawlerProviders' => array(self::HAS_MANY, 'CrawlerProvider', 'crawler_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'directory_url' => Yii::t('app', 'Directory Url'),
            'directory_name' => Yii::t('app', 'Directory Name'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'crawlerProviders' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('directory_url', $this->directory_url, true);
        $criteria->compare('directory_name', $this->directory_name, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
